Package: groovy.lang

## [Java] Class ProxyMetaClass

- groovy.lang.ProxyMetaClass

- All Implemented Interfaces and Traits:
    AdaptingMetaClass

      public class ProxyMetaClass
      extends MetaClassImpl

  As subclass of MetaClass, ProxyMetaClass manages calls from Groovy Objects to POJOs. It enriches MetaClass with the feature of making method invocations interceptable by an Interceptor. To this end, it acts as a decorator (decorator pattern) allowing to add or withdraw this feature at runtime. See groovy/lang/InterceptorTest.groovy for details.

  WARNING: This implementation of ProxyMetaClass is NOT thread-safe and hence should only be used for as a per-instance MetaClass running in a single thread. Do not place this MetaClass in the MetaClassRegistry as it will result in unpredictable behaviour

  Authors:
    Dierk Koenig
    Graeme Rocher
  See Also:
    MetaClassRegistry

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected MetaClass` | `adaptee` |
    `protected Interceptor` | `interceptor` |

  - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class MetaClassImpl` | `EMPTY_ARGUMENTS, INVOKE_METHOD_METHOD, METHOD_MISSING, PROPERTY_MISSING, STATIC_METHOD_MISSING, STATIC_PROPERTY_MISSING, getPropertyMethod, invokeMethodMethod, isGroovyObject, isMap, metaMethodIndex, registry, setPropertyMethod, theCachedClass, theClass`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `ProxyMetaClass (MetaClassRegistry registry, Class theClass, MetaClass adaptee)` @param adaptee the MetaClass to decorate with interceptability

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `MetaClass` | `getAdaptee()`
    `` | `static ProxyMetaClass` | `getInstance(Class theClass)` convenience factory method for the most usual case.
    `` | `Interceptor` | `getInterceptor()` @return the interceptor in use or null if no interceptor is used
    `` | `Object` | `getProperty(Class aClass, Object object, String property, boolean b, boolean b1)` Interceptors the call to getProperty if a PropertyAccessInterceptor is available
    `` | `void` | `initialize()`
    `` | `Object` | `invokeConstructor(Object[] arguments)` Call invokeConstructor on adaptee with logic like in MetaClass unless we have an Interceptor.
    `` | `Object` | `invokeMethod(Object object, String methodName, Object[] arguments)` Call invokeMethod on adaptee with logic like in MetaClass unless we have an Interceptor.
    `` | `Object` | `invokeStaticMethod(Object object, String methodName, Object[] arguments)` Call invokeStaticMethod on adaptee with logic like in MetaClass unless we have an Interceptor.
    `` | `void` | `setAdaptee(MetaClass metaClass)`
    `` | `void` | `setInterceptor(Interceptor interceptor)` @param interceptor may be null to reset any interception
    `` | `void` | `setProperty(Class aClass, Object object, String property, Object newValue, boolean b, boolean b1)` Interceptors the call to a property setter if a PropertyAccessInterceptor is available
    `` | `Object` | `use(Closure closure)` Use the ProxyMetaClass for the given Closure.
    `` | `Object` | `use(GroovyObject object, Closure closure)` Use the ProxyMetaClass for the given Closure.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---

    `class MetaClassImpl`

    `addMetaBeanProperty, addMetaMethod, addMetaMethodToIndex, addNewInstanceMethod, addNewStaticMethod, applyPropertyDescriptors, checkIfGroovyObjectMethod, checkInitalised, chooseMethod, clearInvocationCaches, createConstructorSite, createErrorMessageForAmbiguity, createPogoCallCurrentSite, createPogoCallSite, createPojoCallSite, createStaticSite, createTransformMetaMethod, doChooseMostSpecificParams, dropMethodCache, dropStaticMethodCache, findMethodInClassHierarchy, findMixinMethod, findOwnMethod, findPropertyInClassHierarchy, getAdditionalMetaMethods, getAttribute, getAttribute, getAttribute, getClassInfo, getClassNode, getEffectiveGetMetaProperty, getMetaMethod, getMetaMethods, getMetaProperty, getMethodWithCaching, getMethodWithoutCaching, getMethods, getProperties, getProperty, getProperty, getRegistry, getStaticMetaMethod, getSubclassMetaMethods, getSuperClasses, getTheCachedClass, getTheClass, getVersion, handleMatches, hasCustomInvokeMethod, hasCustomStaticInvokeMethod, hasProperty, incVersion, initialize, invokeConstructor, invokeMethod, invokeMethod, invokeMethod, invokeMissingMethod, invokeMissingProperty, invokeStaticMethod, invokeStaticMissingProperty, isGroovyObject, isInitialized, isModified, onGetPropertyFoundInHierarchy, onInvokeMethodFoundInHierarchy, onMixinMethodFound, onSetPropertyFoundInHierarchy, onSuperMethodFoundInHierarchy, onSuperPropertyFoundInHierarchy, pickMethod, respondsTo, respondsTo, retrieveConstructor, retrieveConstructor, retrieveStaticMethod, selectConstructorAndTransformArguments, setAttribute, setAttribute, setProperties, setProperty, setProperty, toString`

    `class Object` | `equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### protected MetaClass adaptee

    - #### protected Interceptor interceptor

  - ### Constructor Detail

    - #### public ProxyMetaClass(MetaClassRegistry registry, Class theClass, MetaClass adaptee)

      Parameters:
        `adaptee` - the MetaClass to decorate with interceptability

  - ### Method Detail

    - #### public MetaClass getAdaptee()

    - #### public static ProxyMetaClass getInstance(Class theClass)

      convenience factory method for the most usual case.

    - #### public Interceptor getInterceptor()

      Returns:
        the interceptor in use or null if no interceptor is used

    - #### public Object getProperty(Class aClass, Object object, String property, boolean b, boolean b1)

      Interceptors the call to getProperty if a PropertyAccessInterceptor is available

      Parameters:
        `object` - the object to invoke the getter on
        `property` - the property name
      Returns:
        the value of the property

    - #### public void initialize()

    - #### public Object invokeConstructor(Object[] arguments)

      Call invokeConstructor on adaptee with logic like in MetaClass unless we have an Interceptor. With Interceptor the call is nested in its beforeInvoke and afterInvoke methods. The method call is suppressed if Interceptor.doInvoke() returns false. See Interceptor for details.

    - #### public Object invokeMethod(Object object, String methodName, Object[] arguments)

      Call invokeMethod on adaptee with logic like in MetaClass unless we have an Interceptor. With Interceptor the call is nested in its beforeInvoke and afterInvoke methods. The method call is suppressed if Interceptor.doInvoke() returns false. See Interceptor for details.

    - #### public Object invokeStaticMethod(Object object, String methodName, Object[] arguments)

      Call invokeStaticMethod on adaptee with logic like in MetaClass unless we have an Interceptor. With Interceptor the call is nested in its beforeInvoke and afterInvoke methods. The method call is suppressed if Interceptor.doInvoke() returns false. See Interceptor for details.

    - #### public void setAdaptee(MetaClass metaClass)

    - #### public void setInterceptor(Interceptor interceptor)

      Parameters:
        `interceptor` - may be null to reset any interception

    - #### public void setProperty(Class aClass, Object object, String property, Object newValue, boolean b, boolean b1)

      Interceptors the call to a property setter if a PropertyAccessInterceptor is available

      Parameters:
        `object` - The object to invoke the setter on
        `property` - The property name to set
        `newValue` - The new value of the property

    - #### public Object use(Closure closure)

      Use the ProxyMetaClass for the given Closure. Cares for balanced register/unregister.

      Parameters:
        `closure` - piece of code to be executed with registered ProxyMetaClass

    - #### public Object use(GroovyObject object, Closure closure)

      Use the ProxyMetaClass for the given Closure. Cares for balanced setting/unsetting ProxyMetaClass.

      Parameters:
        `closure` - piece of code to be executed with ProxyMetaClass